/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-hrpsys-ros-bridge-1.2.14-0precise-20150820-1540/msg/OpenHRP_AutoBalancerService_Footstep.msg
 *
 */


#ifndef HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_FOOTSTEP_H
#define HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_FOOTSTEP_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace hrpsys_ros_bridge
{
template <class ContainerAllocator>
struct OpenHRP_AutoBalancerService_Footstep_
{
  typedef OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> Type;

  OpenHRP_AutoBalancerService_Footstep_()
    : pos()
    , rot()
    , leg()  {
      pos.assign(0.0);

      rot.assign(0.0);
  }
  OpenHRP_AutoBalancerService_Footstep_(const ContainerAllocator& _alloc)
    : pos()
    , rot()
    , leg(_alloc)  {
      pos.assign(0.0);

      rot.assign(0.0);
  }



   typedef boost::array<double, 3>  _pos_type;
  _pos_type pos;

   typedef boost::array<double, 4>  _rot_type;
  _rot_type rot;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _leg_type;
  _leg_type leg;




  typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct OpenHRP_AutoBalancerService_Footstep_

typedef ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<std::allocator<void> > OpenHRP_AutoBalancerService_Footstep;

typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep > OpenHRP_AutoBalancerService_FootstepPtr;
typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep const> OpenHRP_AutoBalancerService_FootstepConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace hrpsys_ros_bridge

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'hrpsys_ros_bridge': ['/tmp/buildd/ros-hydro-hrpsys-ros-bridge-1.2.14-0precise-20150820-1540/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >
{
  static const char* value()
  {
    return "f65a0e5bbf029cf10add63f7ae123997";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xf65a0e5bbf029cf1ULL;
  static const uint64_t static_value2 = 0x0add63f7ae123997ULL;
};

template<class ContainerAllocator>
struct DataType< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >
{
  static const char* value()
  {
    return "hrpsys_ros_bridge/OpenHRP_AutoBalancerService_Footstep";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float64[3] pos\n\
float64[4] rot\n\
string leg\n\
";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.pos);
      stream.next(m.rot);
      stream.next(m.leg);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct OpenHRP_AutoBalancerService_Footstep_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator>& v)
  {
    s << indent << "pos[]" << std::endl;
    for (size_t i = 0; i < v.pos.size(); ++i)
    {
      s << indent << "  pos[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.pos[i]);
    }
    s << indent << "rot[]" << std::endl;
    for (size_t i = 0; i < v.rot.size(); ++i)
    {
      s << indent << "  rot[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.rot[i]);
    }
    s << indent << "leg: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.leg);
  }
};

} // namespace message_operations
} // namespace ros

#endif // HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_FOOTSTEP_H
