/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-hrpsys-ros-bridge-1.2.14-0precise-20150820-1540/msg/OpenHRP_AutoBalancerService_FootstepParam.msg
 *
 */


#ifndef HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_FOOTSTEPPARAM_H
#define HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_FOOTSTEPPARAM_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <hrpsys_ros_bridge/OpenHRP_AutoBalancerService_Footstep.h>
#include <hrpsys_ros_bridge/OpenHRP_AutoBalancerService_Footstep.h>
#include <hrpsys_ros_bridge/OpenHRP_AutoBalancerService_Footstep.h>
#include <hrpsys_ros_bridge/OpenHRP_AutoBalancerService_Footstep.h>
#include <hrpsys_ros_bridge/OpenHRP_AutoBalancerService_Footstep.h>
#include <hrpsys_ros_bridge/OpenHRP_AutoBalancerService_Footstep.h>
#include <hrpsys_ros_bridge/OpenHRP_AutoBalancerService_Footstep.h>

namespace hrpsys_ros_bridge
{
template <class ContainerAllocator>
struct OpenHRP_AutoBalancerService_FootstepParam_
{
  typedef OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> Type;

  OpenHRP_AutoBalancerService_FootstepParam_()
    : rleg_coords()
    , lleg_coords()
    , support_leg_coords()
    , swing_leg_coords()
    , swing_leg_src_coords()
    , swing_leg_dst_coords()
    , dst_foot_midcoords()
    , support_leg(0)
    , support_leg_with_both(0)  {
    }
  OpenHRP_AutoBalancerService_FootstepParam_(const ContainerAllocator& _alloc)
    : rleg_coords(_alloc)
    , lleg_coords(_alloc)
    , support_leg_coords(_alloc)
    , swing_leg_coords(_alloc)
    , swing_leg_src_coords(_alloc)
    , swing_leg_dst_coords(_alloc)
    , dst_foot_midcoords(_alloc)
    , support_leg(0)
    , support_leg_with_both(0)  {
    }



   typedef  ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator>  _rleg_coords_type;
  _rleg_coords_type rleg_coords;

   typedef  ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator>  _lleg_coords_type;
  _lleg_coords_type lleg_coords;

   typedef  ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator>  _support_leg_coords_type;
  _support_leg_coords_type support_leg_coords;

   typedef  ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator>  _swing_leg_coords_type;
  _swing_leg_coords_type swing_leg_coords;

   typedef  ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator>  _swing_leg_src_coords_type;
  _swing_leg_src_coords_type swing_leg_src_coords;

   typedef  ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator>  _swing_leg_dst_coords_type;
  _swing_leg_dst_coords_type swing_leg_dst_coords;

   typedef  ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator>  _dst_foot_midcoords_type;
  _dst_foot_midcoords_type dst_foot_midcoords;

   typedef int64_t _support_leg_type;
  _support_leg_type support_leg;

   typedef int64_t _support_leg_with_both_type;
  _support_leg_with_both_type support_leg_with_both;




  typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct OpenHRP_AutoBalancerService_FootstepParam_

typedef ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<std::allocator<void> > OpenHRP_AutoBalancerService_FootstepParam;

typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam > OpenHRP_AutoBalancerService_FootstepParamPtr;
typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam const> OpenHRP_AutoBalancerService_FootstepParamConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace hrpsys_ros_bridge

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'hrpsys_ros_bridge': ['/tmp/buildd/ros-hydro-hrpsys-ros-bridge-1.2.14-0precise-20150820-1540/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "d1331ecdbf30a9356b0fe972d9b3ee02";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xd1331ecdbf30a935ULL;
  static const uint64_t static_value2 = 0x6b0fe972d9b3ee02ULL;
};

template<class ContainerAllocator>
struct DataType< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "hrpsys_ros_bridge/OpenHRP_AutoBalancerService_FootstepParam";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "OpenHRP_AutoBalancerService_Footstep rleg_coords\n\
OpenHRP_AutoBalancerService_Footstep lleg_coords\n\
OpenHRP_AutoBalancerService_Footstep support_leg_coords\n\
OpenHRP_AutoBalancerService_Footstep swing_leg_coords\n\
OpenHRP_AutoBalancerService_Footstep swing_leg_src_coords\n\
OpenHRP_AutoBalancerService_Footstep swing_leg_dst_coords\n\
OpenHRP_AutoBalancerService_Footstep dst_foot_midcoords\n\
int64 support_leg\n\
int64 support_leg_with_both\n\
\n\
================================================================================\n\
MSG: hrpsys_ros_bridge/OpenHRP_AutoBalancerService_Footstep\n\
float64[3] pos\n\
float64[4] rot\n\
string leg\n\
";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.rleg_coords);
      stream.next(m.lleg_coords);
      stream.next(m.support_leg_coords);
      stream.next(m.swing_leg_coords);
      stream.next(m.swing_leg_src_coords);
      stream.next(m.swing_leg_dst_coords);
      stream.next(m.dst_foot_midcoords);
      stream.next(m.support_leg);
      stream.next(m.support_leg_with_both);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct OpenHRP_AutoBalancerService_FootstepParam_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_FootstepParam_<ContainerAllocator>& v)
  {
    s << indent << "rleg_coords: ";
    s << std::endl;
    Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >::stream(s, indent + "  ", v.rleg_coords);
    s << indent << "lleg_coords: ";
    s << std::endl;
    Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >::stream(s, indent + "  ", v.lleg_coords);
    s << indent << "support_leg_coords: ";
    s << std::endl;
    Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >::stream(s, indent + "  ", v.support_leg_coords);
    s << indent << "swing_leg_coords: ";
    s << std::endl;
    Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >::stream(s, indent + "  ", v.swing_leg_coords);
    s << indent << "swing_leg_src_coords: ";
    s << std::endl;
    Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >::stream(s, indent + "  ", v.swing_leg_src_coords);
    s << indent << "swing_leg_dst_coords: ";
    s << std::endl;
    Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >::stream(s, indent + "  ", v.swing_leg_dst_coords);
    s << indent << "dst_foot_midcoords: ";
    s << std::endl;
    Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_Footstep_<ContainerAllocator> >::stream(s, indent + "  ", v.dst_foot_midcoords);
    s << indent << "support_leg: ";
    Printer<int64_t>::stream(s, indent + "  ", v.support_leg);
    s << indent << "support_leg_with_both: ";
    Printer<int64_t>::stream(s, indent + "  ", v.support_leg_with_both);
  }
};

} // namespace message_operations
} // namespace ros

#endif // HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_FOOTSTEPPARAM_H
