/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-hrpsys-ros-bridge-1.2.14-0precise-20150820-1540/msg/OpenHRP_AutoBalancerService_GaitGeneratorParam.msg
 *
 */


#ifndef HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_GAITGENERATORPARAM_H
#define HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_GAITGENERATORPARAM_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Float64MultiArray.h>

namespace hrpsys_ros_bridge
{
template <class ContainerAllocator>
struct OpenHRP_AutoBalancerService_GaitGeneratorParam_
{
  typedef OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> Type;

  OpenHRP_AutoBalancerService_GaitGeneratorParam_()
    : default_step_time(0.0)
    , default_step_height(0.0)
    , default_double_support_ratio(0.0)
    , default_double_support_static_ratio(0.0)
    , stride_parameter()
    , default_orbit_type(0)
    , swing_trajectory_delay_time_offset(0.0)
    , swing_trajectory_final_distance_weight(0.0)
    , stair_trajectory_way_point_offset()
    , cycloid_delay_kick_point_offset()
    , gravitational_acceleration(0.0)
    , toe_pos_offset_x(0.0)
    , heel_pos_offset_x(0.0)
    , toe_zmp_offset_x(0.0)
    , heel_zmp_offset_x(0.0)
    , toe_angle(0.0)
    , heel_angle(0.0)
    , toe_heel_phase_ratio()
    , use_toe_joint(false)
    , use_toe_heel_transition(false)
    , leg_default_translate_pos()
    , optional_go_pos_finalize_footstep_num(0)  {
      stride_parameter.assign(0.0);

      stair_trajectory_way_point_offset.assign(0.0);

      cycloid_delay_kick_point_offset.assign(0.0);
  }
  OpenHRP_AutoBalancerService_GaitGeneratorParam_(const ContainerAllocator& _alloc)
    : default_step_time(0.0)
    , default_step_height(0.0)
    , default_double_support_ratio(0.0)
    , default_double_support_static_ratio(0.0)
    , stride_parameter()
    , default_orbit_type(0)
    , swing_trajectory_delay_time_offset(0.0)
    , swing_trajectory_final_distance_weight(0.0)
    , stair_trajectory_way_point_offset()
    , cycloid_delay_kick_point_offset()
    , gravitational_acceleration(0.0)
    , toe_pos_offset_x(0.0)
    , heel_pos_offset_x(0.0)
    , toe_zmp_offset_x(0.0)
    , heel_zmp_offset_x(0.0)
    , toe_angle(0.0)
    , heel_angle(0.0)
    , toe_heel_phase_ratio(_alloc)
    , use_toe_joint(false)
    , use_toe_heel_transition(false)
    , leg_default_translate_pos(_alloc)
    , optional_go_pos_finalize_footstep_num(0)  {
      stride_parameter.assign(0.0);

      stair_trajectory_way_point_offset.assign(0.0);

      cycloid_delay_kick_point_offset.assign(0.0);
  }



   typedef double _default_step_time_type;
  _default_step_time_type default_step_time;

   typedef double _default_step_height_type;
  _default_step_height_type default_step_height;

   typedef double _default_double_support_ratio_type;
  _default_double_support_ratio_type default_double_support_ratio;

   typedef double _default_double_support_static_ratio_type;
  _default_double_support_static_ratio_type default_double_support_static_ratio;

   typedef boost::array<double, 4>  _stride_parameter_type;
  _stride_parameter_type stride_parameter;

   typedef int64_t _default_orbit_type_type;
  _default_orbit_type_type default_orbit_type;

   typedef double _swing_trajectory_delay_time_offset_type;
  _swing_trajectory_delay_time_offset_type swing_trajectory_delay_time_offset;

   typedef double _swing_trajectory_final_distance_weight_type;
  _swing_trajectory_final_distance_weight_type swing_trajectory_final_distance_weight;

   typedef boost::array<double, 3>  _stair_trajectory_way_point_offset_type;
  _stair_trajectory_way_point_offset_type stair_trajectory_way_point_offset;

   typedef boost::array<double, 3>  _cycloid_delay_kick_point_offset_type;
  _cycloid_delay_kick_point_offset_type cycloid_delay_kick_point_offset;

   typedef double _gravitational_acceleration_type;
  _gravitational_acceleration_type gravitational_acceleration;

   typedef double _toe_pos_offset_x_type;
  _toe_pos_offset_x_type toe_pos_offset_x;

   typedef double _heel_pos_offset_x_type;
  _heel_pos_offset_x_type heel_pos_offset_x;

   typedef double _toe_zmp_offset_x_type;
  _toe_zmp_offset_x_type toe_zmp_offset_x;

   typedef double _heel_zmp_offset_x_type;
  _heel_zmp_offset_x_type heel_zmp_offset_x;

   typedef double _toe_angle_type;
  _toe_angle_type toe_angle;

   typedef double _heel_angle_type;
  _heel_angle_type heel_angle;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _toe_heel_phase_ratio_type;
  _toe_heel_phase_ratio_type toe_heel_phase_ratio;

   typedef uint8_t _use_toe_joint_type;
  _use_toe_joint_type use_toe_joint;

   typedef uint8_t _use_toe_heel_transition_type;
  _use_toe_heel_transition_type use_toe_heel_transition;

   typedef  ::std_msgs::Float64MultiArray_<ContainerAllocator>  _leg_default_translate_pos_type;
  _leg_default_translate_pos_type leg_default_translate_pos;

   typedef int32_t _optional_go_pos_finalize_footstep_num_type;
  _optional_go_pos_finalize_footstep_num_type optional_go_pos_finalize_footstep_num;




  typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct OpenHRP_AutoBalancerService_GaitGeneratorParam_

typedef ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<std::allocator<void> > OpenHRP_AutoBalancerService_GaitGeneratorParam;

typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam > OpenHRP_AutoBalancerService_GaitGeneratorParamPtr;
typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam const> OpenHRP_AutoBalancerService_GaitGeneratorParamConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace hrpsys_ros_bridge

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'hrpsys_ros_bridge': ['/tmp/buildd/ros-hydro-hrpsys-ros-bridge-1.2.14-0precise-20150820-1540/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "5e2424e21c9467f9d591b352bb275f35";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x5e2424e21c9467f9ULL;
  static const uint64_t static_value2 = 0xd591b352bb275f35ULL;
};

template<class ContainerAllocator>
struct DataType< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "hrpsys_ros_bridge/OpenHRP_AutoBalancerService_GaitGeneratorParam";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float64 default_step_time\n\
float64 default_step_height\n\
float64 default_double_support_ratio\n\
float64 default_double_support_static_ratio\n\
float64[4] stride_parameter\n\
int64 default_orbit_type\n\
float64 swing_trajectory_delay_time_offset\n\
float64 swing_trajectory_final_distance_weight\n\
float64[3] stair_trajectory_way_point_offset\n\
float64[3] cycloid_delay_kick_point_offset\n\
float64 gravitational_acceleration\n\
float64 toe_pos_offset_x\n\
float64 heel_pos_offset_x\n\
float64 toe_zmp_offset_x\n\
float64 heel_zmp_offset_x\n\
float64 toe_angle\n\
float64 heel_angle\n\
float64[] toe_heel_phase_ratio\n\
bool use_toe_joint\n\
bool use_toe_heel_transition\n\
std_msgs/Float64MultiArray leg_default_translate_pos\n\
int32 optional_go_pos_finalize_footstep_num\n\
\n\
================================================================================\n\
MSG: std_msgs/Float64MultiArray\n\
# Please look at the MultiArrayLayout message definition for\n\
# documentation on all multiarrays.\n\
\n\
MultiArrayLayout  layout        # specification of data layout\n\
float64[]         data          # array of data\n\
\n\
\n\
================================================================================\n\
MSG: std_msgs/MultiArrayLayout\n\
# The multiarray declares a generic multi-dimensional array of a\n\
# particular data type.  Dimensions are ordered from outer most\n\
# to inner most.\n\
\n\
MultiArrayDimension[] dim # Array of dimension properties\n\
uint32 data_offset        # padding bytes at front of data\n\
\n\
# Accessors should ALWAYS be written in terms of dimension stride\n\
# and specified outer-most dimension first.\n\
# \n\
# multiarray(i,j,k) = data[data_offset + dim_stride[1]*i + dim_stride[2]*j + k]\n\
#\n\
# A standard, 3-channel 640x480 image with interleaved color channels\n\
# would be specified as:\n\
#\n\
# dim[0].label  = \"height\"\n\
# dim[0].size   = 480\n\
# dim[0].stride = 3*640*480 = 921600  (note dim[0] stride is just size of image)\n\
# dim[1].label  = \"width\"\n\
# dim[1].size   = 640\n\
# dim[1].stride = 3*640 = 1920\n\
# dim[2].label  = \"channel\"\n\
# dim[2].size   = 3\n\
# dim[2].stride = 3\n\
#\n\
# multiarray(i,j,k) refers to the ith row, jth column, and kth channel.\n\
================================================================================\n\
MSG: std_msgs/MultiArrayDimension\n\
string label   # label of given dimension\n\
uint32 size    # size of given dimension (in type units)\n\
uint32 stride  # stride of given dimension\n\
";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.default_step_time);
      stream.next(m.default_step_height);
      stream.next(m.default_double_support_ratio);
      stream.next(m.default_double_support_static_ratio);
      stream.next(m.stride_parameter);
      stream.next(m.default_orbit_type);
      stream.next(m.swing_trajectory_delay_time_offset);
      stream.next(m.swing_trajectory_final_distance_weight);
      stream.next(m.stair_trajectory_way_point_offset);
      stream.next(m.cycloid_delay_kick_point_offset);
      stream.next(m.gravitational_acceleration);
      stream.next(m.toe_pos_offset_x);
      stream.next(m.heel_pos_offset_x);
      stream.next(m.toe_zmp_offset_x);
      stream.next(m.heel_zmp_offset_x);
      stream.next(m.toe_angle);
      stream.next(m.heel_angle);
      stream.next(m.toe_heel_phase_ratio);
      stream.next(m.use_toe_joint);
      stream.next(m.use_toe_heel_transition);
      stream.next(m.leg_default_translate_pos);
      stream.next(m.optional_go_pos_finalize_footstep_num);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct OpenHRP_AutoBalancerService_GaitGeneratorParam_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::hrpsys_ros_bridge::OpenHRP_AutoBalancerService_GaitGeneratorParam_<ContainerAllocator>& v)
  {
    s << indent << "default_step_time: ";
    Printer<double>::stream(s, indent + "  ", v.default_step_time);
    s << indent << "default_step_height: ";
    Printer<double>::stream(s, indent + "  ", v.default_step_height);
    s << indent << "default_double_support_ratio: ";
    Printer<double>::stream(s, indent + "  ", v.default_double_support_ratio);
    s << indent << "default_double_support_static_ratio: ";
    Printer<double>::stream(s, indent + "  ", v.default_double_support_static_ratio);
    s << indent << "stride_parameter[]" << std::endl;
    for (size_t i = 0; i < v.stride_parameter.size(); ++i)
    {
      s << indent << "  stride_parameter[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.stride_parameter[i]);
    }
    s << indent << "default_orbit_type: ";
    Printer<int64_t>::stream(s, indent + "  ", v.default_orbit_type);
    s << indent << "swing_trajectory_delay_time_offset: ";
    Printer<double>::stream(s, indent + "  ", v.swing_trajectory_delay_time_offset);
    s << indent << "swing_trajectory_final_distance_weight: ";
    Printer<double>::stream(s, indent + "  ", v.swing_trajectory_final_distance_weight);
    s << indent << "stair_trajectory_way_point_offset[]" << std::endl;
    for (size_t i = 0; i < v.stair_trajectory_way_point_offset.size(); ++i)
    {
      s << indent << "  stair_trajectory_way_point_offset[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.stair_trajectory_way_point_offset[i]);
    }
    s << indent << "cycloid_delay_kick_point_offset[]" << std::endl;
    for (size_t i = 0; i < v.cycloid_delay_kick_point_offset.size(); ++i)
    {
      s << indent << "  cycloid_delay_kick_point_offset[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.cycloid_delay_kick_point_offset[i]);
    }
    s << indent << "gravitational_acceleration: ";
    Printer<double>::stream(s, indent + "  ", v.gravitational_acceleration);
    s << indent << "toe_pos_offset_x: ";
    Printer<double>::stream(s, indent + "  ", v.toe_pos_offset_x);
    s << indent << "heel_pos_offset_x: ";
    Printer<double>::stream(s, indent + "  ", v.heel_pos_offset_x);
    s << indent << "toe_zmp_offset_x: ";
    Printer<double>::stream(s, indent + "  ", v.toe_zmp_offset_x);
    s << indent << "heel_zmp_offset_x: ";
    Printer<double>::stream(s, indent + "  ", v.heel_zmp_offset_x);
    s << indent << "toe_angle: ";
    Printer<double>::stream(s, indent + "  ", v.toe_angle);
    s << indent << "heel_angle: ";
    Printer<double>::stream(s, indent + "  ", v.heel_angle);
    s << indent << "toe_heel_phase_ratio[]" << std::endl;
    for (size_t i = 0; i < v.toe_heel_phase_ratio.size(); ++i)
    {
      s << indent << "  toe_heel_phase_ratio[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.toe_heel_phase_ratio[i]);
    }
    s << indent << "use_toe_joint: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.use_toe_joint);
    s << indent << "use_toe_heel_transition: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.use_toe_heel_transition);
    s << indent << "leg_default_translate_pos: ";
    s << std::endl;
    Printer< ::std_msgs::Float64MultiArray_<ContainerAllocator> >::stream(s, indent + "  ", v.leg_default_translate_pos);
    s << indent << "optional_go_pos_finalize_footstep_num: ";
    Printer<int32_t>::stream(s, indent + "  ", v.optional_go_pos_finalize_footstep_num);
  }
};

} // namespace message_operations
} // namespace ros

#endif // HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_AUTOBALANCERSERVICE_GAITGENERATORPARAM_H
