/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-hrpsys-ros-bridge-1.2.14-0precise-20150820-1540/msg/OpenHRP_StabilizerService_stParam.msg
 *
 */


#ifndef HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_STABILIZERSERVICE_STPARAM_H
#define HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_STABILIZERSERVICE_STPARAM_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Float64MultiArray.h>

namespace hrpsys_ros_bridge
{
template <class ContainerAllocator>
struct OpenHRP_StabilizerService_stParam_
{
  typedef OpenHRP_StabilizerService_stParam_<ContainerAllocator> Type;

  OpenHRP_StabilizerService_stParam_()
    : k_tpcc_p()
    , k_tpcc_x()
    , k_brot_p()
    , k_brot_tc()
    , k_run_b()
    , d_run_b()
    , tdfke()
    , tdftc()
    , k_run_x(0.0)
    , k_run_y(0.0)
    , d_run_x(0.0)
    , d_run_y(0.0)
    , eefm_k1()
    , eefm_k2()
    , eefm_k3()
    , eefm_zmp_delay_time_const()
    , eefm_ref_zmp_aux()
    , eefm_rot_damping_gain(0.0)
    , eefm_rot_time_const(0.0)
    , eefm_pos_damping_gain()
    , eefm_pos_time_const_support()
    , eefm_pos_time_const_swing(0.0)
    , eefm_pos_transition_time(0.0)
    , eefm_pos_margin_time(0.0)
    , eefm_leg_inside_margin(0.0)
    , eefm_leg_outside_margin(0.0)
    , eefm_leg_front_margin(0.0)
    , eefm_leg_rear_margin(0.0)
    , eefm_body_attitude_control_gain()
    , eefm_body_attitude_control_time_const()
    , eefm_cogvel_cutoff_freq(0.0)
    , eefm_wrench_alpha_blending(0.0)
    , eefm_alpha_cutoff_freq(0.0)
    , eefm_gravitational_acceleration(0.0)
    , eefm_ee_pos_error_p_gain(0.0)
    , eefm_ee_rot_error_p_gain(0.0)
    , eefm_ee_error_cutoff_freq(0.0)
    , is_ik_enable()
    , st_algorithm(0)
    , controller_mode(0)
    , transition_time(0.0)
    , cop_check_margin(0.0)
    , cp_check_margin(0.0)
    , contact_decision_threshold(0.0)
    , foot_origin_offset()
    , emergency_check_mode(0)  {
      k_tpcc_p.assign(0.0);

      k_tpcc_x.assign(0.0);

      k_brot_p.assign(0.0);

      k_brot_tc.assign(0.0);

      k_run_b.assign(0.0);

      d_run_b.assign(0.0);

      tdfke.assign(0.0);

      tdftc.assign(0.0);

      eefm_k1.assign(0.0);

      eefm_k2.assign(0.0);

      eefm_k3.assign(0.0);

      eefm_zmp_delay_time_const.assign(0.0);

      eefm_ref_zmp_aux.assign(0.0);

      eefm_pos_damping_gain.assign(0.0);

      eefm_pos_time_const_support.assign(0.0);

      eefm_body_attitude_control_gain.assign(0.0);

      eefm_body_attitude_control_time_const.assign(0.0);
  }
  OpenHRP_StabilizerService_stParam_(const ContainerAllocator& _alloc)
    : k_tpcc_p()
    , k_tpcc_x()
    , k_brot_p()
    , k_brot_tc()
    , k_run_b()
    , d_run_b()
    , tdfke()
    , tdftc()
    , k_run_x(0.0)
    , k_run_y(0.0)
    , d_run_x(0.0)
    , d_run_y(0.0)
    , eefm_k1()
    , eefm_k2()
    , eefm_k3()
    , eefm_zmp_delay_time_const()
    , eefm_ref_zmp_aux()
    , eefm_rot_damping_gain(0.0)
    , eefm_rot_time_const(0.0)
    , eefm_pos_damping_gain()
    , eefm_pos_time_const_support()
    , eefm_pos_time_const_swing(0.0)
    , eefm_pos_transition_time(0.0)
    , eefm_pos_margin_time(0.0)
    , eefm_leg_inside_margin(0.0)
    , eefm_leg_outside_margin(0.0)
    , eefm_leg_front_margin(0.0)
    , eefm_leg_rear_margin(0.0)
    , eefm_body_attitude_control_gain()
    , eefm_body_attitude_control_time_const()
    , eefm_cogvel_cutoff_freq(0.0)
    , eefm_wrench_alpha_blending(0.0)
    , eefm_alpha_cutoff_freq(0.0)
    , eefm_gravitational_acceleration(0.0)
    , eefm_ee_pos_error_p_gain(0.0)
    , eefm_ee_rot_error_p_gain(0.0)
    , eefm_ee_error_cutoff_freq(0.0)
    , is_ik_enable(_alloc)
    , st_algorithm(0)
    , controller_mode(0)
    , transition_time(0.0)
    , cop_check_margin(0.0)
    , cp_check_margin(0.0)
    , contact_decision_threshold(0.0)
    , foot_origin_offset(_alloc)
    , emergency_check_mode(0)  {
      k_tpcc_p.assign(0.0);

      k_tpcc_x.assign(0.0);

      k_brot_p.assign(0.0);

      k_brot_tc.assign(0.0);

      k_run_b.assign(0.0);

      d_run_b.assign(0.0);

      tdfke.assign(0.0);

      tdftc.assign(0.0);

      eefm_k1.assign(0.0);

      eefm_k2.assign(0.0);

      eefm_k3.assign(0.0);

      eefm_zmp_delay_time_const.assign(0.0);

      eefm_ref_zmp_aux.assign(0.0);

      eefm_pos_damping_gain.assign(0.0);

      eefm_pos_time_const_support.assign(0.0);

      eefm_body_attitude_control_gain.assign(0.0);

      eefm_body_attitude_control_time_const.assign(0.0);
  }



   typedef boost::array<double, 2>  _k_tpcc_p_type;
  _k_tpcc_p_type k_tpcc_p;

   typedef boost::array<double, 2>  _k_tpcc_x_type;
  _k_tpcc_x_type k_tpcc_x;

   typedef boost::array<double, 2>  _k_brot_p_type;
  _k_brot_p_type k_brot_p;

   typedef boost::array<double, 2>  _k_brot_tc_type;
  _k_brot_tc_type k_brot_tc;

   typedef boost::array<double, 2>  _k_run_b_type;
  _k_run_b_type k_run_b;

   typedef boost::array<double, 2>  _d_run_b_type;
  _d_run_b_type d_run_b;

   typedef boost::array<double, 2>  _tdfke_type;
  _tdfke_type tdfke;

   typedef boost::array<double, 2>  _tdftc_type;
  _tdftc_type tdftc;

   typedef double _k_run_x_type;
  _k_run_x_type k_run_x;

   typedef double _k_run_y_type;
  _k_run_y_type k_run_y;

   typedef double _d_run_x_type;
  _d_run_x_type d_run_x;

   typedef double _d_run_y_type;
  _d_run_y_type d_run_y;

   typedef boost::array<double, 2>  _eefm_k1_type;
  _eefm_k1_type eefm_k1;

   typedef boost::array<double, 2>  _eefm_k2_type;
  _eefm_k2_type eefm_k2;

   typedef boost::array<double, 2>  _eefm_k3_type;
  _eefm_k3_type eefm_k3;

   typedef boost::array<double, 2>  _eefm_zmp_delay_time_const_type;
  _eefm_zmp_delay_time_const_type eefm_zmp_delay_time_const;

   typedef boost::array<double, 2>  _eefm_ref_zmp_aux_type;
  _eefm_ref_zmp_aux_type eefm_ref_zmp_aux;

   typedef double _eefm_rot_damping_gain_type;
  _eefm_rot_damping_gain_type eefm_rot_damping_gain;

   typedef double _eefm_rot_time_const_type;
  _eefm_rot_time_const_type eefm_rot_time_const;

   typedef boost::array<double, 3>  _eefm_pos_damping_gain_type;
  _eefm_pos_damping_gain_type eefm_pos_damping_gain;

   typedef boost::array<double, 3>  _eefm_pos_time_const_support_type;
  _eefm_pos_time_const_support_type eefm_pos_time_const_support;

   typedef double _eefm_pos_time_const_swing_type;
  _eefm_pos_time_const_swing_type eefm_pos_time_const_swing;

   typedef double _eefm_pos_transition_time_type;
  _eefm_pos_transition_time_type eefm_pos_transition_time;

   typedef double _eefm_pos_margin_time_type;
  _eefm_pos_margin_time_type eefm_pos_margin_time;

   typedef double _eefm_leg_inside_margin_type;
  _eefm_leg_inside_margin_type eefm_leg_inside_margin;

   typedef double _eefm_leg_outside_margin_type;
  _eefm_leg_outside_margin_type eefm_leg_outside_margin;

   typedef double _eefm_leg_front_margin_type;
  _eefm_leg_front_margin_type eefm_leg_front_margin;

   typedef double _eefm_leg_rear_margin_type;
  _eefm_leg_rear_margin_type eefm_leg_rear_margin;

   typedef boost::array<double, 2>  _eefm_body_attitude_control_gain_type;
  _eefm_body_attitude_control_gain_type eefm_body_attitude_control_gain;

   typedef boost::array<double, 2>  _eefm_body_attitude_control_time_const_type;
  _eefm_body_attitude_control_time_const_type eefm_body_attitude_control_time_const;

   typedef double _eefm_cogvel_cutoff_freq_type;
  _eefm_cogvel_cutoff_freq_type eefm_cogvel_cutoff_freq;

   typedef double _eefm_wrench_alpha_blending_type;
  _eefm_wrench_alpha_blending_type eefm_wrench_alpha_blending;

   typedef double _eefm_alpha_cutoff_freq_type;
  _eefm_alpha_cutoff_freq_type eefm_alpha_cutoff_freq;

   typedef double _eefm_gravitational_acceleration_type;
  _eefm_gravitational_acceleration_type eefm_gravitational_acceleration;

   typedef double _eefm_ee_pos_error_p_gain_type;
  _eefm_ee_pos_error_p_gain_type eefm_ee_pos_error_p_gain;

   typedef double _eefm_ee_rot_error_p_gain_type;
  _eefm_ee_rot_error_p_gain_type eefm_ee_rot_error_p_gain;

   typedef double _eefm_ee_error_cutoff_freq_type;
  _eefm_ee_error_cutoff_freq_type eefm_ee_error_cutoff_freq;

   typedef std::vector<uint8_t, typename ContainerAllocator::template rebind<uint8_t>::other >  _is_ik_enable_type;
  _is_ik_enable_type is_ik_enable;

   typedef int64_t _st_algorithm_type;
  _st_algorithm_type st_algorithm;

   typedef int64_t _controller_mode_type;
  _controller_mode_type controller_mode;

   typedef double _transition_time_type;
  _transition_time_type transition_time;

   typedef double _cop_check_margin_type;
  _cop_check_margin_type cop_check_margin;

   typedef double _cp_check_margin_type;
  _cp_check_margin_type cp_check_margin;

   typedef double _contact_decision_threshold_type;
  _contact_decision_threshold_type contact_decision_threshold;

   typedef  ::std_msgs::Float64MultiArray_<ContainerAllocator>  _foot_origin_offset_type;
  _foot_origin_offset_type foot_origin_offset;

   typedef int64_t _emergency_check_mode_type;
  _emergency_check_mode_type emergency_check_mode;




  typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct OpenHRP_StabilizerService_stParam_

typedef ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<std::allocator<void> > OpenHRP_StabilizerService_stParam;

typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam > OpenHRP_StabilizerService_stParamPtr;
typedef boost::shared_ptr< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam const> OpenHRP_StabilizerService_stParamConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace hrpsys_ros_bridge

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'hrpsys_ros_bridge': ['/tmp/buildd/ros-hydro-hrpsys-ros-bridge-1.2.14-0precise-20150820-1540/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "733c43ffb05b76e69b0a4704db23b7d3";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x733c43ffb05b76e6ULL;
  static const uint64_t static_value2 = 0x9b0a4704db23b7d3ULL;
};

template<class ContainerAllocator>
struct DataType< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "hrpsys_ros_bridge/OpenHRP_StabilizerService_stParam";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float64[2] k_tpcc_p\n\
float64[2] k_tpcc_x\n\
float64[2] k_brot_p\n\
float64[2] k_brot_tc\n\
float64[2] k_run_b\n\
float64[2] d_run_b\n\
float64[2] tdfke\n\
float64[2] tdftc\n\
float64 k_run_x\n\
float64 k_run_y\n\
float64 d_run_x\n\
float64 d_run_y\n\
float64[2] eefm_k1\n\
float64[2] eefm_k2\n\
float64[2] eefm_k3\n\
float64[2] eefm_zmp_delay_time_const\n\
float64[2] eefm_ref_zmp_aux\n\
float64 eefm_rot_damping_gain\n\
float64 eefm_rot_time_const\n\
float64[3] eefm_pos_damping_gain\n\
float64[3] eefm_pos_time_const_support\n\
float64 eefm_pos_time_const_swing\n\
float64 eefm_pos_transition_time\n\
float64 eefm_pos_margin_time\n\
float64 eefm_leg_inside_margin\n\
float64 eefm_leg_outside_margin\n\
float64 eefm_leg_front_margin\n\
float64 eefm_leg_rear_margin\n\
float64[2] eefm_body_attitude_control_gain\n\
float64[2] eefm_body_attitude_control_time_const\n\
float64 eefm_cogvel_cutoff_freq\n\
float64 eefm_wrench_alpha_blending\n\
float64 eefm_alpha_cutoff_freq\n\
float64 eefm_gravitational_acceleration\n\
float64 eefm_ee_pos_error_p_gain\n\
float64 eefm_ee_rot_error_p_gain\n\
float64 eefm_ee_error_cutoff_freq\n\
bool[] is_ik_enable\n\
int64 st_algorithm\n\
int64 controller_mode\n\
float64 transition_time\n\
float64 cop_check_margin\n\
float64 cp_check_margin\n\
float64 contact_decision_threshold\n\
std_msgs/Float64MultiArray foot_origin_offset\n\
int64 emergency_check_mode\n\
\n\
================================================================================\n\
MSG: std_msgs/Float64MultiArray\n\
# Please look at the MultiArrayLayout message definition for\n\
# documentation on all multiarrays.\n\
\n\
MultiArrayLayout  layout        # specification of data layout\n\
float64[]         data          # array of data\n\
\n\
\n\
================================================================================\n\
MSG: std_msgs/MultiArrayLayout\n\
# The multiarray declares a generic multi-dimensional array of a\n\
# particular data type.  Dimensions are ordered from outer most\n\
# to inner most.\n\
\n\
MultiArrayDimension[] dim # Array of dimension properties\n\
uint32 data_offset        # padding bytes at front of data\n\
\n\
# Accessors should ALWAYS be written in terms of dimension stride\n\
# and specified outer-most dimension first.\n\
# \n\
# multiarray(i,j,k) = data[data_offset + dim_stride[1]*i + dim_stride[2]*j + k]\n\
#\n\
# A standard, 3-channel 640x480 image with interleaved color channels\n\
# would be specified as:\n\
#\n\
# dim[0].label  = \"height\"\n\
# dim[0].size   = 480\n\
# dim[0].stride = 3*640*480 = 921600  (note dim[0] stride is just size of image)\n\
# dim[1].label  = \"width\"\n\
# dim[1].size   = 640\n\
# dim[1].stride = 3*640 = 1920\n\
# dim[2].label  = \"channel\"\n\
# dim[2].size   = 3\n\
# dim[2].stride = 3\n\
#\n\
# multiarray(i,j,k) refers to the ith row, jth column, and kth channel.\n\
================================================================================\n\
MSG: std_msgs/MultiArrayDimension\n\
string label   # label of given dimension\n\
uint32 size    # size of given dimension (in type units)\n\
uint32 stride  # stride of given dimension\n\
";
  }

  static const char* value(const ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.k_tpcc_p);
      stream.next(m.k_tpcc_x);
      stream.next(m.k_brot_p);
      stream.next(m.k_brot_tc);
      stream.next(m.k_run_b);
      stream.next(m.d_run_b);
      stream.next(m.tdfke);
      stream.next(m.tdftc);
      stream.next(m.k_run_x);
      stream.next(m.k_run_y);
      stream.next(m.d_run_x);
      stream.next(m.d_run_y);
      stream.next(m.eefm_k1);
      stream.next(m.eefm_k2);
      stream.next(m.eefm_k3);
      stream.next(m.eefm_zmp_delay_time_const);
      stream.next(m.eefm_ref_zmp_aux);
      stream.next(m.eefm_rot_damping_gain);
      stream.next(m.eefm_rot_time_const);
      stream.next(m.eefm_pos_damping_gain);
      stream.next(m.eefm_pos_time_const_support);
      stream.next(m.eefm_pos_time_const_swing);
      stream.next(m.eefm_pos_transition_time);
      stream.next(m.eefm_pos_margin_time);
      stream.next(m.eefm_leg_inside_margin);
      stream.next(m.eefm_leg_outside_margin);
      stream.next(m.eefm_leg_front_margin);
      stream.next(m.eefm_leg_rear_margin);
      stream.next(m.eefm_body_attitude_control_gain);
      stream.next(m.eefm_body_attitude_control_time_const);
      stream.next(m.eefm_cogvel_cutoff_freq);
      stream.next(m.eefm_wrench_alpha_blending);
      stream.next(m.eefm_alpha_cutoff_freq);
      stream.next(m.eefm_gravitational_acceleration);
      stream.next(m.eefm_ee_pos_error_p_gain);
      stream.next(m.eefm_ee_rot_error_p_gain);
      stream.next(m.eefm_ee_error_cutoff_freq);
      stream.next(m.is_ik_enable);
      stream.next(m.st_algorithm);
      stream.next(m.controller_mode);
      stream.next(m.transition_time);
      stream.next(m.cop_check_margin);
      stream.next(m.cp_check_margin);
      stream.next(m.contact_decision_threshold);
      stream.next(m.foot_origin_offset);
      stream.next(m.emergency_check_mode);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct OpenHRP_StabilizerService_stParam_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::hrpsys_ros_bridge::OpenHRP_StabilizerService_stParam_<ContainerAllocator>& v)
  {
    s << indent << "k_tpcc_p[]" << std::endl;
    for (size_t i = 0; i < v.k_tpcc_p.size(); ++i)
    {
      s << indent << "  k_tpcc_p[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.k_tpcc_p[i]);
    }
    s << indent << "k_tpcc_x[]" << std::endl;
    for (size_t i = 0; i < v.k_tpcc_x.size(); ++i)
    {
      s << indent << "  k_tpcc_x[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.k_tpcc_x[i]);
    }
    s << indent << "k_brot_p[]" << std::endl;
    for (size_t i = 0; i < v.k_brot_p.size(); ++i)
    {
      s << indent << "  k_brot_p[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.k_brot_p[i]);
    }
    s << indent << "k_brot_tc[]" << std::endl;
    for (size_t i = 0; i < v.k_brot_tc.size(); ++i)
    {
      s << indent << "  k_brot_tc[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.k_brot_tc[i]);
    }
    s << indent << "k_run_b[]" << std::endl;
    for (size_t i = 0; i < v.k_run_b.size(); ++i)
    {
      s << indent << "  k_run_b[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.k_run_b[i]);
    }
    s << indent << "d_run_b[]" << std::endl;
    for (size_t i = 0; i < v.d_run_b.size(); ++i)
    {
      s << indent << "  d_run_b[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.d_run_b[i]);
    }
    s << indent << "tdfke[]" << std::endl;
    for (size_t i = 0; i < v.tdfke.size(); ++i)
    {
      s << indent << "  tdfke[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.tdfke[i]);
    }
    s << indent << "tdftc[]" << std::endl;
    for (size_t i = 0; i < v.tdftc.size(); ++i)
    {
      s << indent << "  tdftc[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.tdftc[i]);
    }
    s << indent << "k_run_x: ";
    Printer<double>::stream(s, indent + "  ", v.k_run_x);
    s << indent << "k_run_y: ";
    Printer<double>::stream(s, indent + "  ", v.k_run_y);
    s << indent << "d_run_x: ";
    Printer<double>::stream(s, indent + "  ", v.d_run_x);
    s << indent << "d_run_y: ";
    Printer<double>::stream(s, indent + "  ", v.d_run_y);
    s << indent << "eefm_k1[]" << std::endl;
    for (size_t i = 0; i < v.eefm_k1.size(); ++i)
    {
      s << indent << "  eefm_k1[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.eefm_k1[i]);
    }
    s << indent << "eefm_k2[]" << std::endl;
    for (size_t i = 0; i < v.eefm_k2.size(); ++i)
    {
      s << indent << "  eefm_k2[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.eefm_k2[i]);
    }
    s << indent << "eefm_k3[]" << std::endl;
    for (size_t i = 0; i < v.eefm_k3.size(); ++i)
    {
      s << indent << "  eefm_k3[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.eefm_k3[i]);
    }
    s << indent << "eefm_zmp_delay_time_const[]" << std::endl;
    for (size_t i = 0; i < v.eefm_zmp_delay_time_const.size(); ++i)
    {
      s << indent << "  eefm_zmp_delay_time_const[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.eefm_zmp_delay_time_const[i]);
    }
    s << indent << "eefm_ref_zmp_aux[]" << std::endl;
    for (size_t i = 0; i < v.eefm_ref_zmp_aux.size(); ++i)
    {
      s << indent << "  eefm_ref_zmp_aux[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.eefm_ref_zmp_aux[i]);
    }
    s << indent << "eefm_rot_damping_gain: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_rot_damping_gain);
    s << indent << "eefm_rot_time_const: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_rot_time_const);
    s << indent << "eefm_pos_damping_gain[]" << std::endl;
    for (size_t i = 0; i < v.eefm_pos_damping_gain.size(); ++i)
    {
      s << indent << "  eefm_pos_damping_gain[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.eefm_pos_damping_gain[i]);
    }
    s << indent << "eefm_pos_time_const_support[]" << std::endl;
    for (size_t i = 0; i < v.eefm_pos_time_const_support.size(); ++i)
    {
      s << indent << "  eefm_pos_time_const_support[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.eefm_pos_time_const_support[i]);
    }
    s << indent << "eefm_pos_time_const_swing: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_pos_time_const_swing);
    s << indent << "eefm_pos_transition_time: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_pos_transition_time);
    s << indent << "eefm_pos_margin_time: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_pos_margin_time);
    s << indent << "eefm_leg_inside_margin: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_leg_inside_margin);
    s << indent << "eefm_leg_outside_margin: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_leg_outside_margin);
    s << indent << "eefm_leg_front_margin: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_leg_front_margin);
    s << indent << "eefm_leg_rear_margin: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_leg_rear_margin);
    s << indent << "eefm_body_attitude_control_gain[]" << std::endl;
    for (size_t i = 0; i < v.eefm_body_attitude_control_gain.size(); ++i)
    {
      s << indent << "  eefm_body_attitude_control_gain[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.eefm_body_attitude_control_gain[i]);
    }
    s << indent << "eefm_body_attitude_control_time_const[]" << std::endl;
    for (size_t i = 0; i < v.eefm_body_attitude_control_time_const.size(); ++i)
    {
      s << indent << "  eefm_body_attitude_control_time_const[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.eefm_body_attitude_control_time_const[i]);
    }
    s << indent << "eefm_cogvel_cutoff_freq: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_cogvel_cutoff_freq);
    s << indent << "eefm_wrench_alpha_blending: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_wrench_alpha_blending);
    s << indent << "eefm_alpha_cutoff_freq: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_alpha_cutoff_freq);
    s << indent << "eefm_gravitational_acceleration: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_gravitational_acceleration);
    s << indent << "eefm_ee_pos_error_p_gain: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_ee_pos_error_p_gain);
    s << indent << "eefm_ee_rot_error_p_gain: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_ee_rot_error_p_gain);
    s << indent << "eefm_ee_error_cutoff_freq: ";
    Printer<double>::stream(s, indent + "  ", v.eefm_ee_error_cutoff_freq);
    s << indent << "is_ik_enable[]" << std::endl;
    for (size_t i = 0; i < v.is_ik_enable.size(); ++i)
    {
      s << indent << "  is_ik_enable[" << i << "]: ";
      Printer<uint8_t>::stream(s, indent + "  ", v.is_ik_enable[i]);
    }
    s << indent << "st_algorithm: ";
    Printer<int64_t>::stream(s, indent + "  ", v.st_algorithm);
    s << indent << "controller_mode: ";
    Printer<int64_t>::stream(s, indent + "  ", v.controller_mode);
    s << indent << "transition_time: ";
    Printer<double>::stream(s, indent + "  ", v.transition_time);
    s << indent << "cop_check_margin: ";
    Printer<double>::stream(s, indent + "  ", v.cop_check_margin);
    s << indent << "cp_check_margin: ";
    Printer<double>::stream(s, indent + "  ", v.cp_check_margin);
    s << indent << "contact_decision_threshold: ";
    Printer<double>::stream(s, indent + "  ", v.contact_decision_threshold);
    s << indent << "foot_origin_offset: ";
    s << std::endl;
    Printer< ::std_msgs::Float64MultiArray_<ContainerAllocator> >::stream(s, indent + "  ", v.foot_origin_offset);
    s << indent << "emergency_check_mode: ";
    Printer<int64_t>::stream(s, indent + "  ", v.emergency_check_mode);
  }
};

} // namespace message_operations
} // namespace ros

#endif // HRPSYS_ROS_BRIDGE_MESSAGE_OPENHRP_STABILIZERSERVICE_STPARAM_H
